diff --git b/instrumentation/aox/build/gcc-O3/fts.pg a/instrumentation/aox/build/gcc-O3/fts.pg
new file mode 100644
index 0000000..209ecd4
--- /dev/null
+++ a/instrumentation/aox/build/gcc-O3/fts.pg
@@ -0,0 +1,60 @@
+-- There are a couple of things you need to do manually:
+--
+--     1. psql archiveopteryx -f contrib/tsearch2.sql
+--     2. createlang plpgsql archiveopteryx
+--     3. Find out what your current locale is (e.g. "show lc_ctype")
+--        and execute the following statement (assuming a locale of
+--        'en_US.UTF-8'):
+--
+--        update pg_ts_cfg set locale='en_US.UTF-8' where \\
+--        ts_name='default';
+--
+-- The remainder of the script may then be executed with psql -f fts.pg.
+
+
+-- Allow Archiveopteryx to use tsearch2.
+
+grant select on pg_ts_dict to aox;
+grant select on pg_ts_parser to aox;
+grant select on pg_ts_cfg to aox;
+grant select on pg_ts_cfgmap to aox;
+
+
+-- Create a new GiST index on bodyparts.text, and a trigger to update
+-- the index every time a new entry is inserted.
+
+alter table bodyparts add ftidx tsvector;
+update bodyparts set ftidx=to_tsvector('default',text) where length(text) < 1048576;
+create index bodyparts_ftidx on bodyparts using gist(ftidx);
+vacuum full analyze bodyparts;
+
+create trigger bodyparts_ftupdate before insert on bodyparts
+for each row execute procedure tsearch2(ftidx, text);
+
+
+-- XXX: The following code is disabled, because we use copy ... binary
+-- to populate header_fields, and there's no binary input function for
+-- the tsvector type. Do we have to use INSERT if we're running with
+-- db = postgres+tsearch2? If so, perhaps we can use COPY on structured
+-- and INSERT on unstructured fields?
+--
+-- Create a new GiST index on header_fields.value for Subject fields,
+-- and a trigger to update the index every time a new Subject field
+-- is inserted.
+--
+-- alter table header_fields add subjectidx tsvector;
+-- update header_fields set subjectidx=to_tsvector('default',value) where field=20;
+-- create index hf_subjectidx on header_fields using gist(subjectidx) where field=20;
+-- vacuum full analyze header_fields;
+--
+-- create function tsearch2_subject() returns trigger as $$
+-- begin
+--     if NEW.field = 20 then
+--         perform tsearch2(NEW.subjectidx, NEW.value);
+--     end if;
+--     return NEW;
+-- end;
+-- $$ language plpgsql;
+--
+-- create trigger hf_ftupdate before insert on header_fields
+-- for each row execute procedure tsearch2_subject();
diff --git b/instrumentation/aox/build/gcc-O3/schema.pg a/instrumentation/aox/build/gcc-O3/schema.pg
new file mode 100644
index 0000000..6486eeb
--- /dev/null
+++ a/instrumentation/aox/build/gcc-O3/schema.pg
@@ -0,0 +1,561 @@
+-- See http://archiveopteryx.org/db/ for documentation.
+
+-- Each table is documented in an eponymous /db/ page. For example,
+-- http://archiveopteryx.org/db/addresses describes the addresses
+-- table.
+
+-- Finally, http://archiveopteryx.org/schema is a quick overview.
+
+
+-- This table contains information internal to the mailstore.
+-- For now, its only purpose is to coordinate schema updates.
+
+create table mailstore (
+    -- Grant: select, update
+    revision    integer not null primary key
+);
+insert into mailstore (revision) values (97);
+
+
+-- One entry for each unique address we've encountered.
+
+create extension if not exists citext;
+create table addresses (
+    -- Grant: select, insert
+    id          serial primary key,
+    name        text,
+    localpart   citext,
+    domain      citext
+);
+create unique index addresses_ldn_key on addresses(localpart,domain,name);
+
+
+-- One entry per "other users" namespace. Personal namespaces are
+-- implicitly created within these.
+
+create table namespaces (
+    id          serial primary key,
+    name        text not null unique
+);
+insert into namespaces (name) values ('/users');
+
+
+-- One entry per Archiveopteryx user. Used for authentication.
+
+create table users (
+    id          serial primary key,
+    login       text,
+    secret      text,
+    ldapdn      text,
+    parentspace integer not null references namespaces(id),
+    quota       bigint not null default 2147483647
+);
+create unique index u_l on users (lower(login));
+
+
+-- One entry per group of users.
+
+create table groups (
+    id          serial primary key,
+    name        text
+);
+
+
+-- One entry for each group member.
+
+create table group_members (
+    groupid     integer not null references groups(id),
+    member      integer not null references users(id),
+    primary key (groupid, member)
+);
+
+
+-- One entry per deliverable mailbox.
+
+create table mailboxes (
+    -- Grant: select, insert, update
+    id          serial primary key,
+    name        text not null unique,
+    owner       integer references users(id),
+
+    -- The UID that will be assigned to the next delivered message.
+    -- Incremented after each successful delivery.
+    uidnext     integer not null default 1,
+
+    -- The next modsequence value for this mailbox.
+    nextmodseq  bigint not null default 1,
+
+    -- The UID of the first message that should be marked \\Recent.
+    -- Set to uidnext when each new IMAP session is created.
+    first_recent integer not null default 1,
+
+    -- The IMAP mailbox UIDVALIDITY value, which, along with a message UID,
+    -- is forever guaranteed to uniquely refer to a single message.
+    uidvalidity integer not null default 1,
+
+    -- When a mailbox is deleted, its entry is marked (not removed), so
+    -- that its UIDVALIDITY can be incremented if it is ever re-created.
+    deleted     boolean not null default false
+);
+
+
+-- When aoximport or others create /users/foo/bar, bar needs to own
+-- the mailbox, so ensure that that happens.
+
+create function set_mailbox_owner() returns trigger as $$
+begin
+    if new.owner is null then
+    select into new.owner u.id
+        from users u join namespaces n on (u.parentspace=n.id)
+        where new.name like n.name||'/'||u.login||'/%'
+        or new.name = n.name||'/'||u.login limit 1;
+    end if;
+    return new;
+end;
+$$ language 'plpgsql';
+
+create trigger mailbox_owner_trigger
+before insert on mailboxes for each
+row execute procedure set_mailbox_owner();
+
+-- Ensure that mailboxes cannot be deleted while something relies on
+-- their existence
+
+create function check_mailbox_update() returns trigger as $$
+declare address text;
+begin
+    notify mailboxes_updated;
+    if new.deleted='t' and old.deleted='f' then
+        perform * from mailbox_messages where mailbox=new.id;
+        if found then
+            raise exception '% is not empty', new.name;
+        end if;
+        select a.localpart||'@'||a.domain into address
+            from addresses a join aliases al on (a.id=al.address)
+            where al.mailbox=new.id;
+        if address is not null then
+            raise exception '% used by alias %', new.name, address;
+        end if;
+        perform * from fileinto_targets where mailbox=new.id;
+        if found then
+            raise exception '% is used by sieve fileinto', new.name;
+        end if;
+    end if;
+    return new;
+end;
+$$ language 'plpgsql';
+
+create trigger mailbox_update_trigger
+before update on mailboxes for each
+row execute procedure check_mailbox_update();
+
+
+-- One entry per delivery alias: mail to the given address should be
+-- accepted and delivered into the given mailbox.
+
+create table aliases (
+    -- Grant: select, update
+    id          serial primary key,
+    address     integer not null unique references addresses(id),
+    mailbox     integer not null references mailboxes(id)
+                on delete cascade
+);
+
+
+alter table users add alias integer references aliases(id);
+
+
+-- One row per <identifier, rights> entry for a mailbox.
+
+create table permissions (
+    -- Grant: select, insert, delete, update
+    mailbox     integer not null references mailboxes(id),
+    identifier  text not null,
+    rights      text not null,
+    primary key (mailbox, identifier)
+);
+
+
+-- One entry for each Message-ID that begins a thread (for THREAD=REFS)
+
+create table thread_roots (
+    -- Grant: select, insert, update
+    id          serial primary key,
+    messageid   text not null unique
+);
+
+
+-- One entry per message stored
+
+create table messages (
+    -- Grant: select, insert
+    id          serial primary key,
+    idate       integer not null,
+    rfc822size  integer,
+    thread_root integer references thread_roots(id)
+);
+
+
+-- One (mailbox, uid) entry per message and mailbox.
+
+create table mailbox_messages (
+    -- Grant: select, insert, update
+    mailbox     integer not null references mailboxes(id),
+    uid         integer not null,
+    message     integer not null references messages(id),
+    modseq      bigint not null,
+    seen        boolean not null default false,
+    deleted     boolean not null default false,
+    primary key (mailbox, uid)
+);
+
+create index mm_m on mailbox_messages(message);
+
+
+-- One entry for the text of each unique MIME body part.
+-- Entries here may be shared by more than one message.
+
+create sequence bodypart_ids;
+create table bodyparts (
+    -- Grant: select, insert
+    id          integer default nextval('bodypart_ids') primary key,
+    bytes       integer not null,
+    hash        text not null,
+    text        text,
+    data        bytea
+);
+create index b_h on bodyparts(hash);
+
+
+-- One entry for each bodypart in a message.
+
+create table part_numbers (
+    -- Grant: select, insert
+    message     integer references messages(id) on delete cascade,
+    part        text not null,
+    bodypart    integer references bodyparts(id),
+    bytes       integer,
+    lines       integer,
+    primary key (message, part)
+);
+create index pn_b on part_numbers(bodypart);
+
+
+-- One entry for each field name we've seen (From, To, Subject, etc.).
+-- (This table is partially populated from the field-names file.)
+
+create table field_names (
+    -- Grant: select, insert
+    id          serial primary key,
+    name        text unique
+);
+
+
+-- One entry for each header field in a message, except address fields.
+
+create table header_fields (
+    -- Grant: select, insert
+    id          serial primary key,
+    message     integer not null,
+    part        text not null,
+    position    integer not null,
+    field       integer not null references field_names(id),
+    value       text,
+    unique (message, part, position, field),
+    foreign key (message, part)
+                references part_numbers(message, part)
+                on delete cascade
+);
+
+create index hf_msgid on header_fields(value) where field=13;
+
+
+-- One entry for each address associated with a message. Address
+-- fields are stored as one or more row here.
+
+create table address_fields (
+    -- Grant: select, insert
+    message     integer not null,
+    part        text not null,
+    position    integer not null,
+    field       integer not null,
+    number      integer,
+    address     integer not null references addresses(id),
+    foreign key (message, part)
+                references part_numbers(message, part)
+                on delete cascade
+);
+create index af_mp on address_fields (message, part);
+
+
+-- The Date field from each message.
+
+create table date_fields (
+    -- Grant: select, insert
+    message     integer not null references messages(id)
+                on delete cascade,
+    value       timestamp with time zone
+);
+
+create index df_m on date_fields(message);
+
+
+-- One entry per user-defined flag name to be used in flags.
+
+create table flag_names (
+    -- Grant: select, insert
+    id          serial primary key,
+    name        text
+);
+create unique index fn_uname on flag_names(lower(name));
+
+
+-- One entry per user-defined IMAP message flag per message.
+
+create table flags (
+    -- Grant: select, insert, delete
+    mailbox     integer not null,
+    uid         integer not null,
+    flag        integer not null references flag_names(id),
+    foreign key (mailbox, uid)
+                references mailbox_messages(mailbox, uid)
+                on delete cascade
+);
+create index fl_mu on flags (mailbox, uid);
+
+
+-- One entry per subscribed mailbox per user.
+
+create table subscriptions (
+    -- Grant: select, insert, delete
+    id          serial primary key,
+    owner       integer not null references users(id)
+                on delete cascade,
+    mailbox     integer not null references mailboxes(id),
+    unique(owner, mailbox)
+);
+
+
+-- One entry per vendor- or RFC-defined name to be used in annotations.
+
+create table annotation_names (
+    -- Grant: select, insert
+    id          serial primary key,
+    name        text unique
+);
+
+
+-- One entry per annotation.
+
+create table annotations (
+    -- Grant: select, insert, delete, update
+    id          serial primary key,
+    mailbox     integer not null,
+    uid         integer not null,
+    owner       integer references users(id) on delete cascade,
+    name        integer not null references annotation_names(id),
+    value       text,
+    unique (mailbox, uid, owner, name),
+    foreign key (mailbox, uid)
+                references mailbox_messages(mailbox, uid)
+                on delete cascade
+);
+
+
+-- One entry per SIEVE script owned by a user.
+
+create table scripts (
+    -- Grant: select, insert, delete, update
+    id          serial primary key,
+    owner       integer not null references users(id)
+                on delete cascade,
+    name        text,
+    active      boolean not null default 'f',
+    script      text,
+    unique (owner, name)
+);
+
+
+-- One entry per deleted (EXPUNGEd) message. A row here says "message
+-- #n used to be (mailbox,uid) until it was deleted_by ... at ...". A
+-- given pair of (mailbox,uid) may exist either in mailbox_messages or
+-- here, never in both.
+
+create table deleted_messages (
+    -- Grant: select, insert
+    mailbox     integer not null references mailboxes(id),
+    uid         integer not null,
+    message     integer not null references messages(id)
+                on delete cascade,
+    modseq      bigint not null,
+    deleted_by  integer references users(id),
+    deleted_at  timestamp with time zone not null
+                default current_timestamp,
+    reason      text,
+    primary key (mailbox, uid)
+);
+
+create index dm_mud on deleted_messages(mailbox,uid,deleted_at);
+create index dm_mm on deleted_messages(mailbox,modseq);
+create index dm_m on deleted_messages(message);
+
+
+-- When an entry is inserted into deleted_messages, we delete the
+-- corresponding row from mailbox_messages.
+
+create function delete_message() returns trigger as $$
+begin
+    delete from mailbox_messages where mailbox=NEW.mailbox and uid=NEW.uid;
+    return NULL;
+end;
+$$ language plpgsql security definer;
+
+create trigger deleted_messages_trigger
+after insert on deleted_messages
+for each row execute procedure delete_message();
+
+-- One entry for each pending SMTP-submitted delivery.
+
+create table deliveries (
+    -- Grant: select, insert, delete, update
+    id          serial primary key,
+    sender      integer not null references addresses(id),
+    message     integer not null references messages(id)
+                on delete cascade
+                unique,
+    injected_at timestamp with time zone,
+    expires_at  timestamp with time zone,
+    deliver_after timestamp with time zone
+);
+
+
+-- One entry for each recipient of pending outgoing mail.
+
+create table delivery_recipients (
+    -- Grant: select, insert, update
+    id          serial primary key,
+    delivery    integer not null references deliveries(id)
+                on delete cascade,
+    recipient   integer not null references addresses(id),
+    last_attempt timestamp with time zone,
+    action      integer not null default 0,
+    status      text
+);
+
+
+-- Each entry contains a single user's access key to a given mailbox.
+-- (See URLAUTH, RFC 4467.)
+
+create table access_keys (
+    -- Grant: select, insert, delete
+    userid      integer not null references users(id)
+                on delete cascade,
+    mailbox     integer not null references mailboxes(id)
+                on delete cascade,
+    key         text not null,
+    primary key (userid, mailbox)
+);
+
+
+-- One entry for each bodypart that represents an unparseable message
+-- that was wrapped as an application/octet-stream.
+
+create table unparsed_messages (
+    -- Grant: insert
+    bodypart    integer not null references bodyparts(id)
+                on delete cascade,
+    primary key(bodypart)
+);
+
+
+-- One entry for every autoresponse we send.
+
+create table autoresponses (
+    -- Grant: select, insert
+    id          serial primary key,
+    sent_from   integer not null references addresses(id),
+    sent_to     integer not null references addresses(id),
+    expires_at  timestamp with time zone not null
+                default current_timestamp+interval '7 days',
+    handle      text
+);
+
+
+-- One entry for every (authenticated) connection made to any of the
+-- servers.
+
+create table connections (
+    -- Grant: insert
+    id          serial primary key,
+    userid      integer,
+    username    text,
+    address     inet not null,
+    port        integer not null,
+    mechanism   varchar not null,
+    authfailures integer not null,
+    syntaxerrors integer not null,
+    started_at  timestamp with time zone not null,
+    ended_at    timestamp with time zone not null
+);
+
+
+-- One entry for each mailbox used by a given script as a target for a
+-- "fileinto". These mailboxes must not be deleted, since that would
+-- cause the referring script to fail.
+
+create table fileinto_targets (
+    -- Grant: select, insert, delete
+    id          serial primary key,
+    script      integer not null references scripts(id)
+                on delete cascade,
+    mailbox     integer not null references mailboxes(id),
+    unique(script, mailbox)
+);
+
+
+-- One entry for each message that a poor misguided Exchange/Outlook
+-- contributes to its idea of a thread. Used to turn E/O threading
+-- into what the rest of the universe uses.
+
+create table thread_indexes (
+    -- Grant: select, insert
+    message     integer not null references messages(id)
+                on delete cascade,
+    thread_index text
+);
+
+create index ti_outlook_hack on thread_indexes(thread_index);
+
+
+-- One row for each explicit retention policy defined by the
+-- administrator.
+
+create table retention_policies (
+    id          serial primary key,
+    action      text not null,
+    mailbox     integer references mailboxes(id),
+    duration    integer not null,
+    selector    text,
+    constraint rp_action check (action in ('retain','delete'))
+);
+
+create or replace function notify_retention_policies()
+returns trigger as $$
+begin
+    notify retention_policies_updated;
+    return NULL;
+end;$$ language 'plpgsql';
+
+create trigger retention_policies_trigger
+after insert or update or delete
+on retention_policies
+for each statement
+execute procedure notify_retention_policies();
+
+create or replace function merge_threads(t integer, f integer) returns int as $$
+begin
+    -- Grant: execute
+    update messages set thread_root=t where thread_root=f;
+    return 0;
+end;
+$$ language 'plpgsql' security definer;
diff --git b/hung_patch_from_arnt/aox/core/allocator.cpp a/instrumentation/aox/core/allocator.cpp
index 42c6a50..8571074 100644
--- b/hung_patch_from_arnt/aox/core/allocator.cpp
+++ a/instrumentation/aox/core/allocator.cpp
@@ -432,7 +432,7 @@ void Allocator::deallocate( void * p )
     random binary data.
 
     Scanning long strings is slow. Binary data can give false alarms
-    during pointer scanning, which will lead to memory not being
+    during pointer scanning, which will lead ot memory not being
     freed.
 */
 
@@ -533,8 +533,8 @@ void Allocator::mark()
 }
 
 
-/*! Frees all memory that's no longer in use. This can take some time.
-
+/*! Frees all memory that's no longer in use. This can take some time. 
+ 
     Returns null if entries is null or empty, returns an object in
     entries else. The returned object is (in some sense) the one
     that's responsible for the largest share of allocated memory.
@@ -558,7 +558,7 @@ Garbage * Allocator::free( List<Garbage> * entries )
     uint freed = 0;
     objects = 0;
     ::marked = 0;
-
+    
     Garbage * biggest = 0;
 
     // mark
@@ -918,7 +918,7 @@ void pointers( void * p )
                                 if ( m->payload[n] == p ) {
                                     fprintf( stderr,
                                              "Pointer at 0x%p (in 0x%p, "
-                                             "size <= %d, %u pointers)\\n",
+                                             "size <= %d, %d pointers)\\n",
                                              &m->payload[n],
                                              &m->payload[0],
                                              a->step - bytes,
diff --git b/hung_patch_from_arnt/aox/core/estring.cpp a/instrumentation/aox/core/estring.cpp
index 2c8659f..6f0d394 100644
--- b/hung_patch_from_arnt/aox/core/estring.cpp
+++ a/instrumentation/aox/core/estring.cpp
@@ -946,15 +946,7 @@ uint EString::number( bool * ok, uint base ) const
 EString EString::fromNumber( int64 n, uint base )
 {
     EString r;
-    if (0 == n) {
-        r.append("0");        // Short-circuit, 0 is 0 in any base, no need for extra processing
-    } else {
-        if (n < 0) {
-            n = -n;        // Negate, otherwise negative numbers get messed up
-            r.append("-");    // But we remember we need a - sign
-        }
-        r.appendNumber( n, base );
-    }
+    r.appendNumber( n, base );
     return r;
 }
 
diff --git b/instrumentation/aox/db/downgrades.inc a/instrumentation/aox/db/downgrades.inc
new file mode 100644
index 0000000..7a6212b
--- /dev/null
+++ a/instrumentation/aox/db/downgrades.inc
@@ -0,0 +1,259 @@
+static uint numDowngradeFunctions = 97;
+static const char * downgradeFunctions[98] = {
+    0, // 0 undefined
+    0, // 1 undefined
+    0, // 2 undefined
+    0, // 3 undefined
+    0, // 4 undefined
+    0, // 5 undefined
+    0, // 6 undefined
+    0, // 7 undefined
+    0, // 8 undefined
+    0, // 9 undefined
+    0, // 10 undefined
+    0, // 11 undefined
+    0, // 12 undefined
+    0, // 13 undefined
+    0, // 14 undefined
+    0, // 15 undefined
+    0, // 16 undefined
+    0, // 17 undefined
+    0, // 18 undefined
+    0, // 19 undefined
+    0, // 20 undefined
+    0, // 21 undefined
+    0, // 22 undefined
+    0, // 23 undefined
+    0, // 24 undefined
+    0, // 25 undefined
+    0, // 26 undefined
+    0, // 27 undefined
+    0, // 28 undefined
+    0, // 29 undefined
+    0, // 30 undefined
+    0, // 31 undefined
+    0, // 32 undefined
+    0, // 33 undefined
+    0, // 34 undefined
+    0, // 35 undefined
+    0, // 36 undefined
+    0, // 37 undefined
+    0, // 38 undefined
+    0, // 39 undefined
+    0, // 40 undefined
+    0, // 41 undefined
+    0, // 42 undefined
+    0, // 43 undefined
+    0, // 44 undefined
+    0, // 45 undefined
+    0, // 46 undefined
+    0, // 47 undefined
+    0, // 48 undefined
+    0, // 49 undefined
+    0, // 50 undefined
+    0, // 51 undefined
+    0, // 52 undefined
+    0, // 53 undefined
+    0, // 54 undefined
+    0, // 55 undefined
+    0, // 56 undefined
+    0, // 57 undefined
+    0, // 58 undefined
+    0, // 59 undefined
+    0, // 60 undefined
+    0, // 61 undefined
+    0, // 62 undefined
+    0, // 63 undefined
+    0, // 64 undefined
+    0, // 65 undefined
+    0, // 66 undefined
+    0, // 67 undefined
+    0, // 68 undefined
+    0, // 69 undefined
+    0, // 70 undefined
+    0, // 71 undefined
+    0, // 72 undefined
+    0, // 73 undefined
+    0, // 74 undefined
+    0, // 75 undefined
+    0, // 76 undefined
+    0, // 77 undefined
+    0, // 78 undefined
+    0, // 79 undefined
+
+// step to 80
+    "create or replace function downgrade_to_80()"
+    "returns int as $$"
+    "begin"
+    "    drop trigger mailbox_owner_trigger on mailboxes;"
+    "    drop function set_mailbox_owner();"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 81
+    "create or replace function downgrade_to_81()"
+    "returns int as $$"
+    "begin"
+    "    drop trigger mailbox_update_trigger on mailboxes;"
+    "    drop function check_mailbox_update();"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 82
+    "create or replace function downgrade_to_82()"
+    "returns int as $$"
+    "begin"
+    "    insert into flags (mailbox, uid, flag)"
+    "        select mailbox, uid, (select id from flag_names where name=E'\\\\Seen')"
+    "        from mailbox_messages where seen;"
+    "    insert into flags (mailbox, uid, flag)"
+    "        select mailbox, uid, (select id from flag_names where name=E'\\\\Deleted')"
+    "        from mailbox_messages where deleted;"
+    "    alter table mailbox_messages drop seen, drop deleted;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 83
+    "create or replace function downgrade_to_83()"
+    "returns int as $$"
+    "begin"
+    "    drop table retention_policies;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 84
+    "create or replace function downgrade_to_84()"
+    "returns int as $$"
+    "begin"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 85
+    "create or replace function downgrade_to_85()"
+    "returns int as $$"
+    "begin"
+    "    drop trigger retention_policies_trigger on retention_policies;"
+    "    drop function notify_retention_policies();"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 86
+    "create or replace function downgrade_to_86()"
+    "returns int as $$"
+    "begin"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 87
+    "create or replace function downgrade_to_87()"
+    "returns int as $$"
+    "begin"
+    "    alter table users alter alias set not null;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 88
+    "create or replace function downgrade_to_88()"
+    "returns int as $$"
+    "begin"
+    "    alter table connections add userid integer;"
+    "    update connections set userid=users.id from users where users.login=connections.username;"
+    "    alter table connections drop username;"
+    "    alter table connections add foreign key(userid) references users(id);"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 89
+    "create or replace function downgrade_to_89()"
+    "returns int as $$"
+    "begin"
+    "    alter table deliveries drop deliver_after;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 90
+    "create or replace function downgrade_to_90()"
+    "returns int as $$"
+    "begin"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 91
+    "create or replace function downgrade_to_91()"
+    "returns int as $$"
+    "begin"
+    "    alter table connections drop userid;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 92
+    "create or replace function downgrade_to_92()"
+    "returns int as $$"
+    "begin"
+    "    alter table users drop quota;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 93
+    "create or replace function downgrade_to_93()"
+    "returns int as $$"
+    "begin"
+    "    alter table group_members rename groupid to groupname;"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 94
+    "create or replace function downgrade_to_94()"
+    "returns int as $$"
+    "begin"
+    "    alter table messages drop thread_root;"
+    "    drop table thread_roots;"
+    "    drop function merge_threads(integer,integer);"
+    "    create table threads ("
+    "        id serial primary key,"
+    "        mailbox integer not null references mailboxes(id),"
+    "        subject text,"
+    "        unique (mailbox, subject)"
+    "    );"
+    "    create table thread_members ("
+    "        thread integer not null references threads(id),"
+    "        mailbox integer not null,"
+    "        uid integer not null,"
+    "        primary key (thread, mailbox, uid),"
+    "        foreign key (mailbox, uid) references mailbox_messages(mailbox, uid)"
+    "            on delete cascade"
+    "    );"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 95
+    "create or replace function downgrade_to_95()"
+    "returns int as $$"
+    "begin"
+    "    drop index addresses_ldn_key;"
+    "    alter table addresses alter localpart type text;"
+    "    alter table addresses alter domain type text;"
+    "    create unique index addresses_nld_key on addresses(name,localpart,lower(domain));"
+    "    create index ald on addresses(lower(localpart), lower(domain));"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// step to 96
+    "create or replace function downgrade_to_96()"
+    "returns int as $$"
+    "begin"
+    "    create table views ("
+    "        id          serial primary key,"
+    "        source      integer not null references mailboxes(id)"
+    "                    on delete cascade,"
+    "        view        integer not null references mailboxes(id)"
+    "                    on delete cascade unique,"
+    "        nextmodseq  bigint not null,"
+    "        selector    text"
+    "    );"
+    "    return 0;"
+    "end;$$ language 'plpgsql'",
+
+// dummy final entry
+    0
+};
diff --git b/instrumentation/aox/db/privileges.inc a/instrumentation/aox/db/privileges.inc
new file mode 100644
index 0000000..b96724d
--- /dev/null
+++ a/instrumentation/aox/db/privileges.inc
@@ -0,0 +1,35 @@
+    { "mailstore", true, false, true, false },
+    { "addresses", true, true, false, false },
+    { "namespaces", true, false, false, false },
+    { "users", true, false, false, false },
+    { "groups", true, false, false, false },
+    { "group_members", true, false, false, false },
+    { "mailboxes", true, true, true, false },
+    { "aliases", true, false, true, false },
+    { "permissions", true, true, true, true },
+    { "thread_roots", true, true, true, false },
+    { "messages", true, true, false, false },
+    { "mailbox_messages", true, true, true, false },
+    { "bodyparts", true, true, false, false },
+    { "part_numbers", true, true, false, false },
+    { "field_names", true, true, false, false },
+    { "header_fields", true, true, false, false },
+    { "address_fields", true, true, false, false },
+    { "date_fields", true, true, false, false },
+    { "flag_names", true, true, false, false },
+    { "flags", true, true, false, true },
+    { "subscriptions", true, true, false, true },
+    { "annotation_names", true, true, false, false },
+    { "annotations", true, true, true, true },
+    { "scripts", true, true, true, true },
+    { "deleted_messages", true, true, false, false },
+    { "deliveries", true, true, true, true },
+    { "delivery_recipients", true, true, true, false },
+    { "access_keys", true, true, false, true },
+    { "unparsed_messages", false, true, false, false },
+    { "autoresponses", true, true, false, false },
+    { "connections", false, true, false, false },
+    { "fileinto_targets", true, true, false, true },
+    { "thread_indexes", true, true, false, false },
+    { "retention_policies", true, false, false, false },
+    { "retention_policies", false, false, false, false },
